Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class BinaryExpression

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.expr.BinaryExpression

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

Direct Known Subclasses:
  net.sf.saxon.expr.ArithmeticExpression, BooleanExpression, GeneralComparison, GeneralComparison10, IdentityComparison, RangeExpression, SingletonComparison, ValueComparison, VennExpression

public abstract class BinaryExpression
extends ComputedExpression

Binary Expression: a numeric or boolean expression consisting of the two operands and an operator

See Also:
  Serialized Form

Field Summary
`protected Expression` | `operand0`
`protected Expression` | `operand1`
`protected int` | `operator`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`BinaryExpression(Expression p0, int op, Expression p1)` Create a binary expression identifying the two operands and the operator

Method Summary
`int` | `computeCardinality()` Determine the static cardinality.
`int` | `computeSpecialProperties()` Determine the special properties of this expression
`void` | `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic print of expression structure
`protected java.lang.String` | `displayOperator()`
`boolean` | `equals(java.lang.Object other)` Is this expression the same as another expression?
`Expression[]` | `getOperands()` Get the operands
`int` | `getOperator()` Get the operator
`int` | `hashCode()` Get a hashCode for comparing two expressions.
`protected static boolean` | `isAssociative(int operator)` Determine whether an operator is associative, that is, ((a^b)^c) = (a^(b^c))
`protected static boolean` | `isCommutative(int operator)` Determine whether a binary operator is commutative, that is, A op B = B op A.
`protected static boolean` | `isInverse(int op1, int op2)` Test if one operator is the inverse of another, so that (A op1 B) is equivalent to (B op2 A).
`java.util.Iterator` | `iterateSubExpressions()` Get the immediate subexpressions of this expression
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `promote(PromotionOffer offer)` Promote this expression if possible
`Expression` | `simplify(StaticContext env)` Simplify an expression
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression.

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterate, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, suppressValidation, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.expr.Expression
`getItemType`

Field Detail

### operand0

    protected Expression operand0

### operand1

    protected Expression operand1

### operator

    protected int operator

Constructor Detail

### BinaryExpression

    public BinaryExpression(Expression p0,
                            int op,
                            Expression p1)

  Create a binary expression identifying the two operands and the operator

Parameters:
  `p0` - the left-hand operand
  `op` - the operator, as a token returned by the Tokenizer (e.g. Token.AND)
  `p1` - the right-hand operand

Method Detail

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `ComputedExpression`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression. Default implementation for binary operators that accept any kind of operand

  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Specified by:
    `promote` in interface `Expression`
  Overrides:
    `promote` in class `ComputedExpression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Specified by:
    `iterateSubExpressions` in interface `Expression`
  Overrides:
    `iterateSubExpressions` in class `ComputedExpression`
  Returns:
    an iterator containing the sub-expressions of this expression

### getOperator

    public int getOperator()

  Get the operator

### getOperands

    public Expression[] getOperands()

  Get the operands

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality. Default implementation returns [0..1] if either operand can be empty, or [1..1] otherwise.

  Specified by:
    `computeCardinality` in class `ComputedExpression`

### computeSpecialProperties

    public int computeSpecialProperties()

  Determine the special properties of this expression

  Overrides:
    `computeSpecialProperties` in class `ComputedExpression`
  Returns:
    `StaticProperty.NON_CREATIVE`. This is overridden for some subclasses.

### isCommutative

    protected static boolean isCommutative(int operator)

  Determine whether a binary operator is commutative, that is, A op B = B op A.

  Parameters:
    `operator` -
  Returns:
    true if the operator is commutative

### isAssociative

    protected static boolean isAssociative(int operator)

  Determine whether an operator is associative, that is, ((a^b)^c) = (a^(b^c))

### isInverse

    protected static boolean isInverse(int op1,
                                       int op2)

  Test if one operator is the inverse of another, so that (A op1 B) is equivalent to (B op2 A). Commutative operators are the inverse of themselves and are therefore not listed here.

  Parameters:
    `op1` - the first operator
    `op2` - the second operator
  Returns:
    true if the operators are the inverse of each other

### equals

    public boolean equals(java.lang.Object other)

  Is this expression the same as another expression?

### hashCode

    public int hashCode()

  Get a hashCode for comparing two expressions. Note that this hashcode gives the same result for (A op B) and for (B op A), whether or not the operator is commutative.

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic print of expression structure

  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination

### displayOperator

    protected java.lang.String displayOperator()

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD